
/*  A Bison parser, made from w3_yacc.y with Bison version GNU Bison version 1.22
  */

#define YYBISON 1  /* Identify Bison output.  */


/*---| prototypes |---*/
extern alloca();
void yyerror();

#define	END_OF_INPUT	258
#define	GE	259
#define	LE	260
#define	NE	261
#define	EQ	262
#define	GT	263
#define	LT	264
#define	RE	265
#define	ADD	266
#define	SUB	267
#define	MUL	268
#define	DIV	269
#define	LOGICAL_OR	270
#define	LOGICAL_AND	271
#define	OPEN_BRACKET	272
#define	CLOSE_BRACKET	273
#define	CONNECT	274
#define	CONVERT	275
#define	CLOSE	276
#define	QUERY	277
#define	FREE	278
#define	PRINT	279
#define	PRINT_ROWS	280
#define	FETCH	281
#define	SEEK	282
#define	DATABASE	283
#define	SET	284
#define	SETDEFAULT	285
#define	TRANSLATE	286
#define	TAG_CLOSE	287
#define	IF	288
#define	ELSE	289
#define	FI	290
#define	STRING	291
#define	IDENT	292
#define	TEXT	293
#define	NUM	294
#define	VAR	295
#define	UNKNOWN	296
#define	VARIABLE	297
#define	CHAR	298

#line 20 "w3_yacc.y"

#include <stdio.h>
#include <sys/types.h>
#include <msql.h>

#ifdef OS2
#  include <common\config.h>
#  include <common\portable.h>
#endif

#include "w3-msql.h"


#define YYDEBUG 1

int     doingSet = 0;


#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#ifndef YYSTYPE
#define YYSTYPE int
#endif
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		138
#define	YYFLAG		-32768
#define	YYNTBASE	53

#define YYTRANSLATE(x) ((unsigned)(x) <= 298 ? yytranslate[x] : 82)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    44,
    45,    47,    48,     2,    49,    52,    50,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    46,     2,     2,    51,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41,    42,    43
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     3,     4,     7,    10,    13,    16,    19,    22,    25,
    28,    31,    32,    36,    37,    41,    42,    46,    49,    52,
    55,    58,    62,    66,    69,    72,    76,    81,    85,    89,
    93,    98,   103,   109,   110,   117,   120,   123,   126,   134,
   137,   138,   139,   141,   143,   147,   153,   159,   161,   165,
   169,   171,   173,   175,   177,   179,   184,   186,   188,   190,
   192,   194,   196,   198,   200
};

static const short yyrhs[] = {    54,
     3,     0,     0,    58,    54,     0,    59,    54,     0,    61,
    54,     0,    62,    54,     0,    63,    54,     0,    66,    54,
     0,    64,    54,     0,    65,    54,     0,    60,    54,     0,
     0,    55,    75,    54,     0,     0,    56,    76,    54,     0,
     0,    57,    77,    54,     0,    68,    54,     0,    70,    54,
     0,    71,    54,     0,    67,    54,     0,    19,    37,    32,
     0,    19,    38,    32,     0,    19,    32,     0,    21,    32,
     0,    28,    37,    32,     0,    22,    38,    37,    32,     0,
    23,    37,    32,     0,    24,    38,    32,     0,    26,    37,
    32,     0,    27,    37,    39,    32,     0,    25,    37,    38,
    32,     0,    31,    40,    43,    43,    32,     0,     0,    69,
    33,    44,    72,    45,    32,     0,    34,    32,     0,    35,
    32,     0,    78,    73,     0,    44,    72,    45,    74,    44,
    72,    45,     0,    81,    78,     0,     0,     0,    15,     0,
    16,     0,    20,    40,    32,     0,    29,    40,    46,    78,
    32,     0,    30,    40,    46,    78,    32,     0,    80,     0,
    78,    79,    78,     0,    44,    78,    45,     0,    47,     0,
    48,     0,    49,     0,    50,     0,    40,     0,    51,    37,
    52,    39,     0,    38,     0,    39,     0,     7,     0,     9,
     0,     8,     0,     4,     0,     5,     0,     6,     0,    10,
     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    91,    98,    99,   100,   101,   102,   103,   104,   105,   106,
   107,   108,   108,   109,   109,   110,   110,   111,   112,   113,
   114,   117,   122,   127,   134,   141,   148,   155,   162,   169,
   177,   184,   191,   197,   201,   207,   213,   221,   222,   230,
   235,   247,   248,   253,   261,   271,   281,   291,   292,   296,
   300,   304,   308,   312,   318,   323,   328,   333,   341,   345,
   349,   353,   357,   361,   365
};

static const char * const yytname[] = {   "$","error","$illegal.","END_OF_INPUT",
"GE","LE","NE","EQ","GT","LT","RE","ADD","SUB","MUL","DIV","LOGICAL_OR","LOGICAL_AND",
"OPEN_BRACKET","CLOSE_BRACKET","CONNECT","CONVERT","CLOSE","QUERY","FREE","PRINT",
"PRINT_ROWS","FETCH","SEEK","DATABASE","SET","SETDEFAULT","TRANSLATE","TAG_CLOSE",
"IF","ELSE","FI","STRING","IDENT","TEXT","NUM","VAR","UNKNOWN","VARIABLE","CHAR",
"'('","')'","'='","'*'","'+'","'-'","'/'","'@'","'.'","page","commands","@1",
"@2","@3","connect","close","database","query","free","print","fetch","seek",
"print_rows","translate","if","@4","else","fi","condition","condition_expr",
"logical","convert","set","setdefault","expr","math_op","value","cond_op",""
};
#endif

static const short yyr1[] = {     0,
    53,    54,    54,    54,    54,    54,    54,    54,    54,    54,
    54,    55,    54,    56,    54,    57,    54,    54,    54,    54,
    54,    58,    58,    58,    59,    60,    61,    62,    63,    64,
    65,    66,    67,    69,    68,    70,    71,    72,    72,    73,
    73,    74,    74,    74,    75,    76,    77,    78,    78,    78,
    79,    79,    79,    79,    80,    80,    80,    80,    81,    81,
    81,    81,    81,    81,    81
};

static const short yyr2[] = {     0,
     2,     0,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     0,     3,     0,     3,     0,     3,     2,     2,     2,
     2,     3,     3,     2,     2,     3,     4,     3,     3,     3,
     4,     4,     5,     0,     6,     2,     2,     2,     7,     2,
     0,     0,     1,     1,     3,     5,     5,     1,     3,     3,
     1,     1,     1,     1,     1,     4,     1,     1,     1,     1,
     1,     1,     1,     1,     1
};

static const short yydefact[] = {     2,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     0,     2,     2,
    24,     0,     0,    25,     0,     0,     0,     0,     0,     0,
     0,     0,    36,    37,     1,     0,     2,     0,     2,     0,
     2,     3,     4,    11,     5,     6,     7,     9,    10,     8,
    21,    18,     0,    19,    20,    22,    23,     0,    28,    29,
     0,    30,     0,    26,     0,     0,    13,     0,    15,     0,
    17,     0,    27,    32,    31,     0,    45,     0,     0,    57,
    58,    55,     0,     0,     0,    41,    48,    33,     0,     0,
     0,     0,     0,     0,     0,    62,    63,    64,    59,    61,
    60,    65,    51,    52,    53,    54,    38,     0,     0,     0,
    46,    47,    42,    50,     0,    35,    49,    40,    43,    44,
     0,    56,     0,     0,    39,     0,     0,     0
};

static const short yydefgoto[] = {   136,
    13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    28,    29,    30,    95,   117,
   131,    47,    49,    51,    96,   118,    97,   119
};

static const short yypact[] = {    73,
   -17,    -8,    -2,     2,     4,    10,    11,    12,    33,     0,
    24,    31,    69,    61,    53,    54,    73,    73,    73,    73,
    73,    73,    73,    73,    73,    73,    73,    50,    73,    73,
-32768,    55,    56,-32768,    48,    57,    84,    67,    85,    47,
    87,    77,-32768,-32768,-32768,    81,    73,    83,    73,    86,
    73,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,    80,-32768,-32768,-32768,-32768,    95,-32768,-32768,
    96,-32768,    97,-32768,    88,    98,-32768,    89,-32768,    90,
-32768,    71,-32768,-32768,-32768,   100,-32768,    74,    74,-32768,
-32768,-32768,    71,   101,    92,     3,-32768,-32768,    74,    26,
    30,    94,    -4,    82,   108,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,    74,    74,    19,
-32768,-32768,     7,-32768,   102,-32768,   -31,   -31,-32768,-32768,
    99,-32768,    71,   103,-32768,   133,   142,-32768
};

static const short yypgoto[] = {-32768,
     8,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   -79,-32768,
-32768,-32768,-32768,-32768,   -28,-32768,-32768,-32768
};


#define	YYLAST		148


static const short yytable[] = {   106,
   107,   108,   109,   110,   111,   112,   106,   107,   108,   109,
   110,   111,   112,   102,    31,   113,   114,   115,   116,    32,
    33,   129,   130,    34,    52,    53,    54,    55,    56,    57,
    58,    59,    60,    61,    62,    35,    64,    65,    36,    42,
   124,    37,   113,   114,   115,   116,    38,    39,    40,   113,
   114,   115,   116,   134,    77,    43,    79,   121,    81,   100,
   101,   122,    44,   124,   103,   113,   114,   115,   116,    41,
   120,    45,   113,   114,   115,   116,   113,   114,   115,   116,
    46,    48,    63,    50,    68,    73,    66,    67,    69,   127,
   128,     1,   -12,     2,     3,     4,     5,     6,     7,     8,
     9,   -14,   -16,    10,    71,   -34,    11,    12,    90,    91,
    92,    90,    91,    92,    93,    70,    72,    99,    74,    75,
    76,    94,    78,    82,    94,    80,    83,    84,    85,    87,
    86,    98,   137,   125,    88,    89,   105,   104,   123,   126,
   132,   138,   133,     0,     0,     0,     0,   135
};

static const short yycheck[] = {     4,
     5,     6,     7,     8,     9,    10,     4,     5,     6,     7,
     8,     9,    10,    93,    32,    47,    48,    49,    50,    37,
    38,    15,    16,    32,    17,    18,    19,    20,    21,    22,
    23,    24,    25,    26,    27,    38,    29,    30,    37,    40,
    45,    38,    47,    48,    49,    50,    37,    37,    37,    47,
    48,    49,    50,   133,    47,    32,    49,    32,    51,    88,
    89,    32,    32,    45,    93,    47,    48,    49,    50,    37,
    99,     3,    47,    48,    49,    50,    47,    48,    49,    50,
    20,    29,    33,    30,    37,    39,    32,    32,    32,   118,
   119,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    28,    29,    30,    31,    38,    33,    34,    35,    38,    39,
    40,    38,    39,    40,    44,    32,    32,    44,    32,    43,
    40,    51,    40,    44,    51,    40,    32,    32,    32,    32,
    43,    32,     0,    52,    46,    46,    45,    37,    45,    32,
    39,     0,    44,    -1,    -1,    -1,    -1,    45
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/sprachen/lib/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Bob Corbett and Richard Stallman

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 1, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */


#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         -2
#define YYEOF           0
#define YYACCEPT        return(0)
#define YYABORT         return(1)
#define YYERROR         goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL          goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do                                                              \
  if (yychar == YYEMPTY && yylen == 1)                          \
    { yychar = (token), yylval = (value);                       \
      yychar1 = YYTRANSLATE (yychar);                           \
      YYPOPSTACK;                                               \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    { yyerror ("syntax error: cannot back up"); YYERROR; }      \
while (0)

#define YYTERROR        1
#define YYERRCODE       256

#ifndef YYPURE
#define YYLEX           yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#define YYLEX           yylex(&yylval, &yylloc)
#else
#define YYLEX           yylex(&yylval)
#endif
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int     yychar;                 /*  the lookahead symbol                */
YYSTYPE yylval;                 /*  the semantic value of the           */
                                /*  lookahead symbol                    */

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;                 /*  location data for the lookahead     */
                                /*  symbol                              */
#endif

int yynerrs;                    /*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;                    /*  nonzero means print parse trace     */
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks       */

#ifndef YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1                /* GNU C and GNU C++ define this.  */
#define __yy_bcopy(FROM,TO,COUNT)       __builtin_memcpy(TO,FROM,COUNT)
#else                           /* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (from, to, count)
     char *from;
     char *to;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_bcopy (char *from, char *to, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 184 "/sprachen/lib/bison.simple"
int
yyparse()
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;      /*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;              /*  lookahead token as an internal (translated) token number */

  short yyssa[YYINITDEPTH];     /*  the state stack                     */
  YYSTYPE yyvsa[YYINITDEPTH];   /*  the semantic value stack            */

  short *yyss = yyssa;          /*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;        /*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];   /*  the location stack                  */
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;                /*  the variable used to return         */
                                /*  semantic values from the action     */
                                /*  routines                            */

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;             /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
         the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
         but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
                 &yyss1, size * sizeof (*yyssp),
                 &yyvs1, size * sizeof (*yyvsp),
                 &yyls1, size * sizeof (*yylsp),
                 &yystacksize);
#else
      yyoverflow("parser stack overflow",
                 &yyss1, size * sizeof (*yyssp),
                 &yyvs1, size * sizeof (*yyvsp),
                 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
        {
          yyerror("parser stack overflow");
          return 2;
        }
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
        yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_bcopy ((char *)yyss1, (char *)yyss, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_bcopy ((char *)yyvs1, (char *)yyvs, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_bcopy ((char *)yyls1, (char *)yyls, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
        fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
        YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
        fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)              /* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;           /* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
        fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
        {
          fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
          /* Give the individual parser a way to print the precise meaning
             of a token, for further debugging info.  */
#ifdef YYPRINT
          YYPRINT (stderr, yychar, yylval);
#endif
          fprintf (stderr, ")\n");
        }
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
               yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
        fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 92 "w3_yacc.y"
{
                sendFooter();
          ;
    break;}
case 12:
#line 108 "w3_yacc.y"
{doingSet=1;;
    break;}
case 14:
#line 109 "w3_yacc.y"
{doingSet=1;;
    break;}
case 16:
#line 110 "w3_yacc.y"
{doingSet=1;;
    break;}
case 22:
#line 118 "w3_yacc.y"
{
                if (checkIf())
                        doConnect(yyvsp[-1]);
          ;
    break;}
case 23:
#line 123 "w3_yacc.y"
{
                if (checkIf())
                        doConnect(yyvsp[-1]);
          ;
    break;}
case 24:
#line 128 "w3_yacc.y"
{
                if (checkIf())
                        doConnect(NULL);
          ;
    break;}
case 25:
#line 135 "w3_yacc.y"
{
                if (checkIf())
                        doClose();
          ;
    break;}
case 26:
#line 142 "w3_yacc.y"
{
                if (checkIf())
                        doDatabase(yyvsp[-1]);
          ;
    break;}
case 27:
#line 149 "w3_yacc.y"
{
                if (checkIf())
                        doQuery(yyvsp[-2], yyvsp[-1]);
          ;
    break;}
case 28:
#line 156 "w3_yacc.y"
{
                if (checkIf())
                        doFree(yyvsp[-1]);
          ;
    break;}
case 29:
#line 163 "w3_yacc.y"
{
                if (checkIf())
                        doField(yyvsp[-1]);
          ;
    break;}
case 30:
#line 170 "w3_yacc.y"
{
                if (checkIf())
                        doFetch(yyvsp[-1]);
          ;
    break;}
case 31:
#line 178 "w3_yacc.y"
{
                if (checkIf())
                        doSeek(yyvsp[-2], yyvsp[-1]);
          ;
    break;}
case 32:
#line 185 "w3_yacc.y"
{
                if (checkIf())
                        doPrintRows(yyvsp[-2],yyvsp[-1]);
          ;
    break;}
case 33:
#line 192 "w3_yacc.y"
{
                if (checkIf())
                        doTranslate(yyvsp[-3], yyvsp[-2], yyvsp[-1]);
          ;
    break;}
case 34:
#line 198 "w3_yacc.y"
{
                startIf();
          ;
    break;}
case 35:
#line 202 "w3_yacc.y"
{
                endIfCond();
          ;
    break;}
case 36:
#line 208 "w3_yacc.y"
{
                doElse();
          ;
    break;}
case 37:
#line 214 "w3_yacc.y"
{
                endIf();
          ;
    break;}
case 39:
#line 223 "w3_yacc.y"
{
                if(checkIf())
                        doLogical(yyvsp[-3]);
          ;
    break;}
case 40:
#line 231 "w3_yacc.y"
{
                if(checkIf())
                        doComparison(yyvsp[-1]);
          ;
    break;}
case 41:
#line 236 "w3_yacc.y"
{
                if(checkIf())
                {
                        addValue(strdup("0"),NUM);
                        doComparison(NE);
                }
          ;
    break;}
case 43:
#line 249 "w3_yacc.y"
{
                yyval = (u_char *)LOGICAL_OR;
          ;
    break;}
case 44:
#line 254 "w3_yacc.y"
{
                yyval = (u_char *)LOGICAL_AND;
          ;
    break;}
case 45:
#line 262 "w3_yacc.y"
{
                if (checkIf())
                {
                        convertVariable(yyvsp[-1]);
                        doingSet = 0;
                }
          ;
    break;}
case 46:
#line 272 "w3_yacc.y"
{
                if (checkIf())
                {
                        doSet(yyvsp[-3]);
                        doingSet = 0;
                }
          ;
    break;}
case 47:
#line 282 "w3_yacc.y"
{
                if (checkIf())
                {
                        doSetDefault(yyvsp[-3]);
                        doingSet = 0;
                }
          ;
    break;}
case 49:
#line 293 "w3_yacc.y"
{
                doMath(yyvsp[-1]);
          ;
    break;}
case 51:
#line 301 "w3_yacc.y"
{
                yyval = (u_char *) MUL;
          ;
    break;}
case 52:
#line 305 "w3_yacc.y"
{
                yyval = (u_char *) ADD;
          ;
    break;}
case 53:
#line 309 "w3_yacc.y"
{
                yyval = (u_char *) SUB;
          ;
    break;}
case 54:
#line 313 "w3_yacc.y"
{
                yyval = (u_char *) DIV;
          ;
    break;}
case 55:
#line 319 "w3_yacc.y"
{
                if(checkIf()  || doingSet)
                        addValue(yyvsp[0],VAR);
          ;
    break;}
case 56:
#line 324 "w3_yacc.y"
{
                if(checkIf() || doingSet)
                        addRowValue(yyvsp[-2],yyvsp[0]);
          ;
    break;}
case 57:
#line 329 "w3_yacc.y"
{
                if(checkIf() || doingSet )
                        addValue(yyvsp[0],TEXT);
          ;
    break;}
case 58:
#line 334 "w3_yacc.y"
{
                if(checkIf() || doingSet)
                        addValue(yyvsp[0],NUM);
          ;
    break;}
case 59:
#line 342 "w3_yacc.y"
{
                yyval = (u_char *) EQ;
          ;
    break;}
case 60:
#line 346 "w3_yacc.y"
{
                yyval = (u_char *) LT;
          ;
    break;}
case 61:
#line 350 "w3_yacc.y"
{
                yyval = (u_char *) GT;
          ;
    break;}
case 62:
#line 354 "w3_yacc.y"
{
                yyval = (u_char *) GE;
          ;
    break;}
case 63:
#line 358 "w3_yacc.y"
{
                yyval = (u_char *) LE;
          ;
    break;}
case 64:
#line 362 "w3_yacc.y"
{
                yyval = (u_char *) NE;
          ;
    break;}
case 65:
#line 366 "w3_yacc.y"
{
                yyval = (u_char *) RE;
          ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 465 "/sprachen/lib/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
        fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
        {
          int size = 0;
          char *msg;
          int x, count;

          count = 0;
          /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
          for (x = (yyn < 0 ? -yyn : 0);
               x < (sizeof(yytname) / sizeof(char *)); x++)
            if (yycheck[x + yyn] == x)
              size += strlen(yytname[x]) + 15, count++;
          msg = (char *) malloc(size + 15);
          if (msg != 0)
            {
              strcpy(msg, "parse error");

              if (count < 5)
                {
                  count = 0;
                  for (x = (yyn < 0 ? -yyn : 0);
                       x < (sizeof(yytname) / sizeof(char *)); x++)
                    if (yycheck[x + yyn] == x)
                      {
                        strcat(msg, count == 0 ? ", expecting `" : " or `");
                        strcat(msg, yytname[x]);
                        strcat(msg, "'");
                        count++;
                      }
                }
              yyerror(msg);
              free(msg);
            }
          else
            yyerror ("parse error; also virtual memory exceeded");
        }
      else
#endif /* YYERROR_VERBOSE */
        yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
        YYABORT;

#if YYDEBUG != 0
      if (yydebug)
        fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;              /* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
        fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
        goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 370 "w3_yacc.y"
